module PlanetExpress
  class ShipmentRepository < Repository
    def rule_applied_in_month?(month, rule)
      valid_shipments.any? do |shipment|
        shipment.month == month &&
          shipment.discounts.any? { |discount| discount.rule.instance_of?(rule) }
      end
    end

    def l_shipment_count_for_provider_and_month(provider, month)
      valid_shipments.select do |shipment|
        shipment.month == month &&
          shipment.l_shipment? &&
          shipment.provider == provider
      end.length
    end

    private

    def valid_shipments
      valid_shipments = []
      data.each do |shipment|
        shipment.if_valid do |valid_shipment|
          valid_shipments.push(valid_shipment)
        end
      end
      valid_shipments
    end
  end
end
